<?

class imageWorks_imageWorks {
	var $srcPath = "";
	var $destPath = "";
	var $maxWidth = 100;
	var $maxHeight = 100;
	var $quality = 75;
	var $crop = false; // not implemented jet
	
	var $width = -1;
	var $height = -1;
	var $gotInfo = false;
	
	var $rendered = false;

	function srcFile($fileName) {
		$this->rendered = false;
		if (!file_exists($fileName)) return false;
		$this->srcPath = $fileName;
		return true;
	}

	function destFile($fileName) {
		$this->rendered = false;
		$this->destPath = $fileName;	
	}
	
	function maxWidth($maxWidth) {
		$this->rendered = false;
		$this->maxWidth = $maxWidth+0;
	}

	function maxHeight($maxHeight) {
		$this->rendered = false;
		$this->maxHeight = $maxHeight+0;
	}

	function crop($cropImage) {
		$this->rendered = false;
		$this->crop = $cropImage == true;
	}
	
	function quality($quality) {
		$this->rendered = false;
		$this->quality = $quality+0;
	}
	
	function boolToString($bool) {
		return $bool ? "true":"false";
	}
		
	function filterSettings() {
		return "";	
	}
		
	function generateFile() {
		$geometry = "";
		require_once("class.imageWorks_imageInfo.php");
		$info = &new imageWorks_imageInfo($this->srcPath);
		
		if (($this->maxWidth < $info->width) | ($this->maxHeight < $info->height)) {
			$geometry = "-geometry " . $this->maxWidth . "x" . $this->maxHeight;
		}
		
		$command = ri2imageworks_imageMagic_path . "convert " . $geometry . " -colorspace RGB -quality " . $this->quality . " -antialias -interlace none -flatten -adjoin \"" . $this->srcPath . "\"  +profile \"*\" +comment jpeg:" . $this->destPath;

		$x = `$command`;
	}

	function loadFromCache() {
		// we don't have a cache...	
	}
	
	function writeToCache() {
		// we don't have a cache...	
	}

	function render() {
		if (!file_exists($this->srcPath)) return null;
		
		$this->loadFromCache();
		
		if ($this->rendered) return $this->destPath;
		
		$this->gotInfo = false;

/*
		$this->destPath = tempnam(ri2temppath, "imageWorks_");
		unlink($this->destPath);
		$this->destPath .= ".jpg";
*/
		
		$this->generateFile();
				
		if (!file_exists($this->destPath)) return null;
		
		$this->rendered = true;
		
		$this->writeToCache();
		
		return $this->destPath;
	}
	
	function getInfo() {
		if ($this->gotInfo) return;
		if (!$this->rendered) return;
		
		$size = GetImageSize($this->destPath);
		
		if (!is_array(@$size)) return;
		
		$this->height = $size[1];
		$this->width = $size[0];
		
		$this->gotInfo = true;
	}
	
	function getWidth() {
		$this->getInfo();
		return $this->width;
	}

	function getHeight() {
		$this->getInfo();
		return $this->height;
	}
}

?>